*+
*+
*+    Source Module => F:\FILETRAN\FILETRAN.PRG
*+
*+    Functions: Procedure FILETRAN()
*+
*+    Reformatted by Click! 1.11 on Nov-8-1997 at 12:05 am
*+
*+

#include "FILEIO.CH"

*+
*+
*+    Procedure FILETRAN()
*+
*+
*+
procedure FILETRAN( cInFile, cOutFile, cLookFor, cRepWith )

local cBuffer
local nBytesRead

/*

Released to public domain 08/09/96 by author, Phil Barnett

You can change the buffer size but too large will begin slowing it down.
Play with it to find optimum, but remember, the actual performance is
pretty much hardware related. In other words, optimum size on a hard
disk may be very different that optimum size on a network, or even
another hard drive. I find that multiples of 2048 are best (cluster
sizes) On the other hand, it begins to need more and more working memory
as you increase the buffer size. certainly there will be a tradeoff
between usability and speed.

*/

local nSize := 4096

local nInHandle
local cDataIn   := ''
local nLookLen  := len( cLookFor ) - 1  // very important

local nOutHandle
local cDataOut

nInHandle := fopen( cInFile, FO_SHARED ) // open for shared read/write
IF nInHandle == -1
   ? 'Error opening Input file.'
   return .f.
endif

nOutHandle := fcreate( cOutFile, 0 )
IF nOutHandle == -1
   ? 'Error creating Output file.'
   return .f.
endif

nBytesRead := nSize
cBuffer    := space( nSize )

do while nBytesRead == nSize

   nBytesRead := fread( nInHandle, @cBuffer, nSize )

   cDataIn  += left( cBuffer, nBytesRead )
   cDataOut := strtran( cDataIn, cLookFor, cRepWith )

   if nBytesRead == nSize  // there's more, keep nLookLen bytes for next loop
      cDataIn  := right( cDataOut, nLookLen )
      cDataOut := left( cDataOut, len( cDataOut ) - nLookLen )
   endif

   fwrite( nOutHandle, cDataOut )

enddo

fclose( nInHandle )
fclose( nOutHandle )

return

*+ EOF: FILETRAN.PRG
